<div id="panel">
  <div id="content">
    <div class="${this.getRenderState() === 'loading' ? '' : 'hidden'}">
      <div class="message">
        <div i18n="Connecting to the print server, please wait."></div>
        <img alt="loading-icon" src="icons/loading.svg" class="gg-spin" />
      </div>
    </div>

    <div class="${this.getRenderState() === 'error' ? '' : 'hidden'}">
      <div class="message" i18n="The print server is unavailable. Please, try later."></div>
    </div>

    <div class="${this.getRenderState() === 'setup' ? '' : 'hidden'}">
      <div class="option">
        <label for="layout" i18n="Layout" class="gg-label">Layout</label>
        <select id="layout" class="gg-select" onchange="${(evt:Event) => this.onLayoutChanged(evt)}">
          ${this.layouts.map((layout) => uHtml`
          <option i18n="${layout.name}" ?selected="${this.selectedLayout?.name === layout.name}" value="${layout.name}">
            ${layout.name}
          </option>
          `)}
        </select>
      </div>

      <div class="option">
        <label for="scale" i18n="Scale" class="gg-label">Scale</label>
        <select id="scale" class="gg-select" onchange="${(evt:Event) => this.onScaleChanged(evt)}">
          ${this.scales.map((scale) => uHtml`
          <option ?selected="${this.getSelectedScale() === scale}" value="${scale}">
            <span>1&nbsp;:&nbsp;</span><span i18n="${scale}" i18nFn="formatNumber">${scale}</span>
          </option>
          `)}
        </select>
      </div>

      <div class="option">
        <label for="format" i18n="Format" class="gg-label">Format</label>
        <select id="format" class="gg-select" onchange="${(evt:Event) => this.onFormatChanged(evt)}">
          ${this.printFormats.map((format) => uHtml`
          <option ?selected="${this.getSelectedFormat() === format}" value="${format}">${format.toUpperCase()}</option>
          `)}
        </select>
      </div>

      ${ this.dpis.length < 2 ? null : uHtml`
      <div class="option">
        <label for="dpi" class="gg-label">DPI</label>
        <select id="dpi" class="gg-select" onchange="${(evt:Event) => this.onDpiChanged(evt)}">
          ${this.dpis.map((dpi) => uHtml`
          <option ?selected="${this.getSelectedDpi() === dpi}" value="${dpi}">${dpi}</option>
          `)}
        </select>
      </div>
      `}

      <div class="option">
        <label for="rotationSlider" i18n="Rotation" class="gg-label">Rotation</label>
        <div class="rotation">
          <input
            id="rotationSlider"
            class="gg-range"
            type="range"
            min="-180"
            max="180"
            step="1"
            value="${this.getRotation()}"
            oninput="${(evt:Event) => this.onInputRotationChanged(evt)}" />
          <input
            id="rotationNumber"
            class="gg-input"
            type="number"
            min="-180"
            max="180"
            step="1"
            value="${this.getRotation()}"
            oninput="${(evt:Event) => this.onInputRotationChanged(evt)}" />
        </div>
      </div>

      <!-- prettier is breaking this line because it breaks just after the return -->
      <!-- prettier-ignore -->
      ${this.attributeNames.map( (attrName) => { if (this.getAttributeInputType(attrName) === 'number') { return uHtml`
      <div class="option">
        <label for="${attrName}" i18n="${this.attrNameForI18n(attrName)}" class="gg-label">${attrName}</label>
        <input
          id="${attrName}"
          type="number"
          class="gg-input"
          value="${this.getCapabilitiesAttribute(attrName)?.default}" />
      </div>
      `} if (this.getAttributeInputType(attrName) === 'checkbox') { return uHtml`
      <div class="option">
        <label for="${attrName}" i18n="${this.attrNameForI18n(attrName)}" class="gg-label">${attrName}</label>
        <input
          id="${attrName}"
          type="checkbox"
          class="gg-checkbox"
          ?checked="${this.getCapabilitiesAttribute(attrName)?.default}" />
      </div>
      `} if (this.getAttributeInputType(attrName) === 'textarea') { return uHtml`
      <div class="option">
        <!-- prettier-ignore -->
        <textarea
          id="${attrName}"
          class="gg-textarea"
          i18n="${this.attrNameForI18n(attrName)}"
          placeholder="${attrName}">${this.getCapabilitiesAttribute(attrName)?.default}</textarea>
      </div>
      `} return uHtml`
      <div class="option">
        <input
          id="${this.attrNameForI18n(attrName)}"
          class="gg-input"
          i18n="${attrName}"
          placeholder="${attrName}"
          type="text"
          value="${this.getCapabilitiesAttribute(attrName)?.default}" />
      </div>
      `})}

      <button id="export-pdf" class="gg-button" onclick="${() => this.print()}" i18n="Print">Print</button>

      <div id="print-list">
        ${this.printList.map((printItem) => uHtml`
        <div id="${printItem.id}" class="print-item" title="${printItem.elementTitle}">
          <button class="cancel" tabindex="0" onclick="${() => this.onCancelPrintElementClicked(printItem.id)}">
            <img alt="close-icon" src="icons/close.svg" />
          </button>
          <button class="container" tabindex="0" onclick="${() => this.onPrintElementClicked(printItem.id)}">
            <img
              alt="loading-icon"
              src="icons/loading.svg"
              class="${printItem.status === PrintStatus.Started ? 'gg-spin' : 'hidden'}" />
            <img
              alt="loading-icon"
              src="icons/download.svg"
              class="${printItem.status === PrintStatus.Success ? '' : 'hidden'}" />
            <img
              alt="loading-icon"
              src="icons/error.svg"
              class="${printItem.status === PrintStatus.Errored ? '' : 'hidden'}" />
            <p>
              <span i18n="${printItem.selectedLayoutName}">${printItem.selectedLayoutName}</span>
              <span>(</span><span>${printItem.selectedFormat.toUpperCase()}</span><span>)</span>
            </p>
            <p class="time">${printItem.time}</p>
          </button>
        </div>
        `)}
      </div>
    </div>
  </div>
</div>
